/*************************************************************************
 *                                                                       *
 * password.h - header file with extracted passwords file structure.     *
 *************************************************************************/

#ifndef PASSWORD_H
#define PASSWORD_H
#include "globals.h"

#ifdef __cplusplus
extern "C" {
#endif


/*
 * The PASSWORD.NDS struct and a global pointer
 */
typedef struct password
{
        uint32          selfOffset;     /* Offset in PASSWORD.NDS. If this is
                                           the first record, it is 0x00000000
                                           followed by 0x0000014e for the
                                           second record, etc. */
        uint32          id;             /* Object ID from ENTRY */
        uint32          parentID;       /* Parent ID */
        uint32          objectID;       /* Object ID from Private Key */
        uint32          pwlen;          /* Password length of user account */
        uint8           hash[16];       /* One-way hash */
        uint8           userOU[40];     /* OU of User */
        uint8           userCN[258];    /* User common name */
} PASSWORD; /* size=334 */

PASSWORD pPassword; /* password's pointer */
 
#ifdef __cplusplus
}
#endif

#endif /* PASSWORD_H */
